#define MICON_RETRY_NUM 3
#define LCD_BUFFER_ROW 16
#define LCD_BUFFER_COL 2

#define STATE_OFF   0
#define STATE_ON    1
#define STATE_BLINK 2

#define OP_WRITE 0x00
#define OP_READ  0x80

#define DT_SIZE_0 0x00
#define DT_SIZE_1 0x01
#define DT_SIZE_2 0x02
#define DT_SIZE_4 0x04
#define DT_SIZE_6 0x06
#define DT_SIZE_16 0x10
#define DT_SIZE_32 0x20

#define OP_CODE_BZ_ON	0x30
#define DT_BZ_STOP	0x00
#define DT_BZ_MACHINE	0x01
#define DT_BZ_BUTTON	0x02
#define DT_BZ_CONTINUE	0x03
#define DT_BZ_SWITCH1	0x04
#define DT_BZ_SWITCH2	0x10
#define DT_BZ_MUSIC1	0x30
#define DT_BZ_MUSIC2	0x20

#define OP_CODE_LED_CPU_MCON	0x50
#define OP_CODE_LED_ON_OFF	0x51
#define OP_CODE_LED_BLINK	0x52
#define DT_LED_POWER	0x0009
#define DT_LED_INFO	0x0002
#define DT_LED_ALARM	0x0004
#define DT_LED_LINK1	0x0020
#define DT_LED_LINK2	0x0040
#define DT_LED_EXECUTE	0x0090
#define DT_LED_DISP	0x0800
#define DT_LED_RED	0x0100
#define DT_LED_GREEN	0x0200
#define DT_LED_BLUE	0x0400

#define OP_CODE_SATA_LED_ON_OFF	0x58
#define OP_CODE_SATA_LED_BLINK	0x59
#define DT_SATA_LED_1_E	0x0001
#define DT_SATA_LED_2_E	0x0002
#define DT_SATA_LED_3_E	0x0004
#define DT_SATA_LED_4_E	0x0008
#define DT_SATA_LED_5_E	0x0010
#define DT_SATA_LED_6_E	0x0020
#define DT_SATA_LED_7_E	0x0040
#define DT_SATA_LED_8_E	0x0080
#define DT_SATA_LED_1	0x0100
#define DT_SATA_LED_2	0x0200
#define DT_SATA_LED_3	0x0400
#define DT_SATA_LED_4	0x0800
#define DT_SATA_LED_5	0x1000
#define DT_SATA_LED_6	0x2000
#define DT_SATA_LED_7	0x4000
#define DT_SATA_LED_8	0x8000

#define OP_CODE_LCD_DISP_BUF_BASE 0xA0

#define OP_CODE_LCD_DISP_ON_OFF		0x32
#define OP_CODE_LCD_DISP_ON_OFF_EX	0x40
#define DT_DISP_LINK	0x0001
#define DT_DISP_DISK	0x0002
#define DT_DISP_HOST	0x0004
#define DT_DISP_OP	0x0008
#define DT_DISP_DATE	0x0010
#define DT_DISP_BUFF0	0x0020
#define DT_DISP_BUFF1	0x0040
#define DT_DISP_BUFF2	0x0080
#define DT_DISP_BUFF3	0x0100
#define DT_DISP_BUFF4	0x0200
#define DT_DISP_BUFF5	0x0400
#define DT_DISP_BUFF6	0x0800
#define DT_DISP_BUFF7	0x1000

#define OP_CODE_DISP_BASE      0x20
#define OP_CODE_DISP_LINK      0x00
#define OP_CODE_DISP_HOSTNAME  0x01
#define OP_CODE_DISP_IPADDRESS 0x02
#define OP_CODE_DISP_OPMODE    0x03
#define OP_CODE_DISP_DATE      0x04
#define OP_CODE_DISP_BUFF0     0x05
#define OP_CODE_DISP_BUFF1     0x06
#define OP_CODE_DISP_BUFF2     0x07
#define OP_CODE_DISP_BUFF3     0x0b
#define OP_CODE_DISP_BUFF4     0x0c
#define OP_CODE_DISP_BUFF5     0x0d
#define OP_CODE_DISP_BUFF6     0x0e
#define OP_CODE_DISP_BUFF7     0x0f

#define OP_CODE_LED_BRIGHTNESS	0x3a
#define DT_BRIGHTNESS_OFF	0x00
#define DT_BRIGHTNESS_MAX	0x0f

/* ========================================================================== */
/* =========================== UART ========================================= */
/* ========================================================================== */
void send_preamble(void);
int send_cmd (unsigned char, unsigned char, unsigned char, unsigned char*);

/* ========================================================================== */
/* =========================== MICON ======================================== */
/* ========================================================================== */
grub_err_t micon_bz_on (unsigned char);
grub_err_t micon_led_ctrl (unsigned char, unsigned short);
grub_err_t micon_sataled_ctrl (unsigned char, unsigned short);
grub_err_t micon_lcd_set_buff (unsigned int, unsigned char*);
grub_err_t micon_lcd_disp_ctrl (unsigned char, unsigned short);
grub_err_t micon_lcd_disp_item (unsigned char);
grub_err_t micon_led_brightness (unsigned char, unsigned char);
